% program for Conley, Goncalves, Kim, and Perron (QE, 2022)
% computes results plotted in Figure 2

% columns are
% N = 25  
%  N = 100
%   N = 400

% Lines are:

% iid
% CS-HAC
% white
% iid boot
% SDWB

% 10,000 reps



% N(0,2) measurement error

DGP1_0 = [7.2	5.5	4.9
11.3	7.0	5.6
10.2	6.1	5.2
5.8	4.9	5.0
6.8	5.3	5.1


 ];
    
DGP1_1 = [8.9	8.0	8.7
13.7	9.8	8.8
12.8	9.0	8.9
7.6	7.2	7.5
9.0	7.4	7.1

    ];

DGP1_2 = [11.1	11.4	12.6
16.4	13.6	11.8
15.4	12.5	13.0
9.3	10.0	9.2
10.9	10.1	8.6


    ];

DGP1_3 = [14.7	14.8	16.6
20.1	16.5	13.4
19.3	16.2	17.2
12.1	12.4	9.1
13.8	12.4	8.1


];

DGP1_4 = [17.0	20.5	22.4
23.4	21.7	15.7
22.2	22.0	23.0
14.5	16.6	9.6
16.7	15.8	8.2

];

DGP1_5 = [20.3	26.0	31.0
27.2	26.5	18.7
25.9	28.3	31.6
17.6	20.1	10.7
20.0	18.7	7.9

];

DGP1_6 = [25.3	33.4	40.5
31.6	32.2	21.5
30.5	35.5	41.5
22.1	24.2	11.8
24.2	21.8	8.3

];

DGP1_7 = [28.4	40.7	52.4
34.7	37.6	27.1
33.4	42.7	53.6
25.1	27.8	15.5
27.6	23.7	10.0

];

DGP1_8 = [33.7	48.1	63.1
40.3	42.9	31.4
39.4	50.3	63.9
30.0	32.1	18.2
32.5	26.9	10.6

 ];

DGP1_9 = [37.5	56.2	72.8
44.6	48.1	40.0
43.4	58.0	73.9
34.3	36.0	23.9
36.9	29.0	13.6

  ];


rho = [0:.1:.9]';
out25 = [DGP1_0(2,1),DGP1_1(2,1),DGP1_2(2,1),DGP1_3(2,1),DGP1_4(2,1),DGP1_5(2,1),DGP1_6(2,1),DGP1_7(2,1),DGP1_8(2,1),DGP1_9(2,1)
        DGP1_0(4,1),DGP1_1(4,1),DGP1_2(4,1),DGP1_3(4,1),DGP1_4(4,1),DGP1_5(4,1),DGP1_6(4,1),DGP1_7(4,1),DGP1_8(4,1),DGP1_9(4,1)
    DGP1_0(5,1),DGP1_1(5,1),DGP1_2(5,1),DGP1_3(5,1),DGP1_4(5,1),DGP1_5(5,1),DGP1_6(5,1),DGP1_7(5,1),DGP1_8(5,1),DGP1_9(5,1)
   ];

out100 = [DGP1_0(2,2),DGP1_1(2,2),DGP1_2(2,2),DGP1_3(2,2),DGP1_4(2,2),DGP1_5(2,2),DGP1_6(2,2),DGP1_7(2,2),DGP1_8(2,2),DGP1_9(2,2)
        DGP1_0(4,2),DGP1_1(4,2),DGP1_2(4,2),DGP1_3(4,2),DGP1_4(4,2),DGP1_5(4,2),DGP1_6(4,2),DGP1_7(4,2),DGP1_8(4,2),DGP1_9(4,2)
       DGP1_0(5,2),DGP1_1(5,2),DGP1_2(5,2),DGP1_3(5,2),DGP1_4(5,2),DGP1_5(5,2),DGP1_6(5,2),DGP1_7(5,2),DGP1_8(5,2),DGP1_9(5,2)];


out400 = [DGP1_0(2,3),DGP1_1(2,3),DGP1_2(2,3),DGP1_3(2,3),DGP1_4(2,3),DGP1_5(2,3),DGP1_6(2,3),DGP1_7(2,3),DGP1_8(2,3),DGP1_9(2,3)
        DGP1_0(4,3),DGP1_1(4,3),DGP1_2(4,3),DGP1_3(4,3),DGP1_4(4,3),DGP1_5(4,3),DGP1_6(4,3),DGP1_7(4,3),DGP1_8(4,3),DGP1_9(4,3)
   DGP1_0(5,3),DGP1_1(5,3),DGP1_2(5,3),DGP1_3(5,3),DGP1_4(5,3),DGP1_5(5,3),DGP1_6(5,3),DGP1_7(5,3),DGP1_8(5,3),DGP1_9(5,3)] ;
   

subplot(3,1,1,'replace');
plot(rho,out25(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out25(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
 plot(rho,out25(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');
ylim([0 50]);
title('n = 25')
xlabel('\theta');
ylabel('%');
yticks(5:5:50)
text(.1,60,'Figure 2. Rejection rate with N(0,2) error in locations', 'FontSize',14,'FontWeight','bold'); 
 line([0 .9],[5 5],'LineWidth',1.5,'Color','k');    
 
  h = legend('N(0,1) critical values', 'iid bootstrap (Bester et al.)','Spatial Dependent Wild Bootstrap (SDWB)', 'Orientation','Vertical');
 legend('boxon');
 set(h,'FontSize',8);
 set(h,'Location','NorthWest');

   
subplot(3,1,2,'replace');
plot(rho,out100(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out100(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out100(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 100');
    line([0 .9],[5 5],'LineWidth',2,'Color','k');
    ylim([0 50]);
    xlabel('\theta');
    ylabel('%');
yticks(5:5:50)

subplot(3,1,3,'replace');
plot(rho,out400(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out400(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out400(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 400')
ylim([0 50]);
xlabel('\theta');
ylabel('%');
yticks(5:5:50)

     line([0 .9],[5 5],'LineWidth',2,'Color','k');


orient portrait
      print -dpdf -fillpage figure2