% % programs for Conley, Goncalves, Kim, and Perron (QE, 2022)
% plots Figure 1

% columns are
% N = 25  
%  N = 100
%   N = 400

% Lines are:

% iid
% CS-HAC
% white
% iid boot
% SDWB

% 10,000 reps

% Gaussian kernel

% no measurement error

DGP1_0 = [7.2	5.5	4.9
12.6	7.3	5.6
10.2	6.3	5.2
5.9	5.1	4.8
6.8	5.6	5.0

 ];
    
DGP1_1 = [8.9	7.9	9.0
14.6	8.6	7.1
12.8	8.9	9.3
6.7	5.7	5.8
7.4	5.7	5.6


    ];

DGP1_2 = [11.1	11.4	11.7
16.8	10.3	7.7
15.4	12.4	11.8
7.9	6.6	5.7
7.9	6.2	5.5


    ];

DGP1_3 = [14.7	15.5	16.7
19.7	13.2	9.1
19.3	16.8	17.2
9.7	7.5	6.3
9.1	6.8	5.6


];

DGP1_4 = [
17.0	20.2	23.1
22.1	15.7	11.1
22.2	21.5	23.7
11.4	9.0	7.0
9.6	7.3	5.8

];

DGP1_5 = [20.3	26.6	31.0
25.1	18.9	13.7
25.9	28.3	31.7
12.7	10.6	7.8
10.9	8.0	6.5

];

DGP1_6 = [25.3	33.3	41.4
28.9	22.5	17.0
30.5	35.2	42.2
15.4	11.9	9.1
12.2	8.2	7.2

];

DGP1_7 = [28.5	41.8	52.1
31.3	27.5	20.7
33.4	43.8	53.2
17.1	14.4	11.1
13.3	9.0	7.4


];

DGP1_8 = [33.7	48.6	63.6
36.3	31.4	27.5
39.4	51.0	64.4
20.5	17.4	15.1
15.5	10.6	8.9

 ];

DGP1_9 = [37.5	56.4	73.0
39.6	38.4	35.4
43.4	58.3	73.9
23.1	22.4	20.1
17.7	13.1	11.0

  ];


rho = [0:.1:.9]';
out25 = [DGP1_0(2,1),DGP1_1(2,1),DGP1_2(2,1),DGP1_3(2,1),DGP1_4(2,1),DGP1_5(2,1),DGP1_6(2,1),DGP1_7(2,1),DGP1_8(2,1),DGP1_9(2,1)
        DGP1_0(4,1),DGP1_1(4,1),DGP1_2(4,1),DGP1_3(4,1),DGP1_4(4,1),DGP1_5(4,1),DGP1_6(4,1),DGP1_7(4,1),DGP1_8(4,1),DGP1_9(4,1)
    DGP1_0(5,1),DGP1_1(5,1),DGP1_2(5,1),DGP1_3(5,1),DGP1_4(5,1),DGP1_5(5,1),DGP1_6(5,1),DGP1_7(5,1),DGP1_8(5,1),DGP1_9(5,1)
   ];

out100 = [DGP1_0(2,2),DGP1_1(2,2),DGP1_2(2,2),DGP1_3(2,2),DGP1_4(2,2),DGP1_5(2,2),DGP1_6(2,2),DGP1_7(2,2),DGP1_8(2,2),DGP1_9(2,2)
        DGP1_0(4,2),DGP1_1(4,2),DGP1_2(4,2),DGP1_3(4,2),DGP1_4(4,2),DGP1_5(4,2),DGP1_6(4,2),DGP1_7(4,2),DGP1_8(4,2),DGP1_9(4,2)
       DGP1_0(5,2),DGP1_1(5,2),DGP1_2(5,2),DGP1_3(5,2),DGP1_4(5,2),DGP1_5(5,2),DGP1_6(5,2),DGP1_7(5,2),DGP1_8(5,2),DGP1_9(5,2)];


out400 = [DGP1_0(2,3),DGP1_1(2,3),DGP1_2(2,3),DGP1_3(2,3),DGP1_4(2,3),DGP1_5(2,3),DGP1_6(2,3),DGP1_7(2,3),DGP1_8(2,3),DGP1_9(2,3)
        DGP1_0(4,3),DGP1_1(4,3),DGP1_2(4,3),DGP1_3(4,3),DGP1_4(4,3),DGP1_5(4,3),DGP1_6(4,3),DGP1_7(4,3),DGP1_8(4,3),DGP1_9(4,3)
   DGP1_0(5,3),DGP1_1(5,3),DGP1_2(5,3),DGP1_3(5,3),DGP1_4(5,3),DGP1_5(5,3),DGP1_6(5,3),DGP1_7(5,3),DGP1_8(5,3),DGP1_9(5,3)] ;
   

subplot(3,1,1,'replace');
plot(rho,out25(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out25(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
 plot(rho,out25(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');
ylim([0 50]);
title('n = 25')
xlabel('\theta');
ylabel('%');
yticks(5:5:50)
text(0.1,60,'Figure 1. Rejection rate with no measurement error', 'FontSize',14,'FontWeight','bold'); 
 line([0 .9],[5 5],'LineWidth',1.5,'Color','k');    
 
  h = legend('N(0,1) critical values', 'iid bootstrap (Bester et al.)','Spatial Dependent Wild Bootstrap (SDWB)', 'Orientation','Vertical');
 legend('boxon');
 set(h,'FontSize',8);
 set(h,'Location','NorthWest');

    
subplot(3,1,2,'replace');
plot(rho,out100(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out100(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out100(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 100');
    line([0 .9],[5 5],'LineWidth',2,'Color','k');
    ylim([0 50]);
    xlabel('\theta');
    ylabel('%');
yticks(5:5:50)

subplot(3,1,3,'replace');
plot(rho,out400(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out400(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out400(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 400')
ylim([0 50]);
xlabel('\theta');
ylabel('%');
yticks(5:5:50)

     line([0 .9],[5 5],'LineWidth',2,'Color','k');


orient portrait
      print -dpdf -fillpage figure1