% program for Conley, Goncalves, Kim, and Perron (QE, 2022)
% computes results plotted in Figure 4

% columns are
% N = 25  
%  N = 100
%   N = 400

% Lines are:

% iid
% CS-HAC
% white
% iid boot
% SDWB

% 10,000 reps


% 
% % N(0,10) measurement error
% 
DGP1_0 = [7.2	5.5	4.9
11.1	6.7	5.5
10.2	6.1	5.2
5.9	5.0	4.8
7.0	5.2	5.1


 ];
    
DGP1_1 = [8.9	8.0	8.7
13.2	9.7	9.3
12.8	9.0	8.9
7.7	7.4	8.4
9.1	7.9	8.5

    ];

DGP1_2 = [11.1	11.4	12.6
16.0	13.3	13.1
15.4	12.5	13.0
9.2	10.7	11.8
11.0	11.1	11.6


    ];

DGP1_3 = [14.7	14.8	16.6
19.9	16.8	16.7
19.3	16.2	17.2
12.3	14.1	15.0
14.4	14.5	14.4
];

DGP1_4 = [17.0	20.5	22.4
22.9	22.6	22.1
22.2	22.0	23.0
14.6	19.2	19.1
16.7	19.8	18.2

];

DGP1_5 = [20.3	26.0	31.0
26.5	29.1	28.2
25.9	28.3	31.6
17.9	25.3	23.4
20.7	25.5	21.8

];

DGP1_6 = [25.3	33.4	40.5
31.1	35.7	33.6
30.5	35.5	41.5
21.8	31.9	26.0
24.8	32.3	22.6

];

DGP1_7 = [28.4	40.7	52.4
34.3	43.0	40.7
33.4	42.7	53.6
24.7	39.1	30.2
28.3	39.3	24.9

];

DGP1_8 = [33.7	48.1	63.1
39.9	50.2	45.4
39.4	50.3	63.9
30.4	46.4	33.2
33.7	46.1	25.6

 ];

DGP1_9 = [37.5	56.2	72.8
43.9	57.5	54.9
43.4	58.0	73.9
34.2	53.6	43.2
37.6	53.2	33.6

  ];


rho = [0:.1:.9]';
out25 = [DGP1_0(2,1),DGP1_1(2,1),DGP1_2(2,1),DGP1_3(2,1),DGP1_4(2,1),DGP1_5(2,1),DGP1_6(2,1),DGP1_7(2,1),DGP1_8(2,1),DGP1_9(2,1)
        DGP1_0(4,1),DGP1_1(4,1),DGP1_2(4,1),DGP1_3(4,1),DGP1_4(4,1),DGP1_5(4,1),DGP1_6(4,1),DGP1_7(4,1),DGP1_8(4,1),DGP1_9(4,1)
    DGP1_0(5,1),DGP1_1(5,1),DGP1_2(5,1),DGP1_3(5,1),DGP1_4(5,1),DGP1_5(5,1),DGP1_6(5,1),DGP1_7(5,1),DGP1_8(5,1),DGP1_9(5,1)
   ];

out100 = [DGP1_0(2,2),DGP1_1(2,2),DGP1_2(2,2),DGP1_3(2,2),DGP1_4(2,2),DGP1_5(2,2),DGP1_6(2,2),DGP1_7(2,2),DGP1_8(2,2),DGP1_9(2,2)
        DGP1_0(4,2),DGP1_1(4,2),DGP1_2(4,2),DGP1_3(4,2),DGP1_4(4,2),DGP1_5(4,2),DGP1_6(4,2),DGP1_7(4,2),DGP1_8(4,2),DGP1_9(4,2)
       DGP1_0(5,2),DGP1_1(5,2),DGP1_2(5,2),DGP1_3(5,2),DGP1_4(5,2),DGP1_5(5,2),DGP1_6(5,2),DGP1_7(5,2),DGP1_8(5,2),DGP1_9(5,2)];


out400 = [DGP1_0(2,3),DGP1_1(2,3),DGP1_2(2,3),DGP1_3(2,3),DGP1_4(2,3),DGP1_5(2,3),DGP1_6(2,3),DGP1_7(2,3),DGP1_8(2,3),DGP1_9(2,3)
        DGP1_0(4,3),DGP1_1(4,3),DGP1_2(4,3),DGP1_3(4,3),DGP1_4(4,3),DGP1_5(4,3),DGP1_6(4,3),DGP1_7(4,3),DGP1_8(4,3),DGP1_9(4,3)
   DGP1_0(5,3),DGP1_1(5,3),DGP1_2(5,3),DGP1_3(5,3),DGP1_4(5,3),DGP1_5(5,3),DGP1_6(5,3),DGP1_7(5,3),DGP1_8(5,3),DGP1_9(5,3)] ;
   

subplot(3,1,1,'replace');
plot(rho,out25(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out25(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
 plot(rho,out25(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');
ylim([0 60]);
title('n = 25')
xlabel('\theta');
ylabel('%');
yticks(5:5:60)
 text(.1,70,'Figure 4. Rejection rate with N(0,10) error in locations', 'FontSize',14,'FontWeight','bold'); 
 line([0 .9],[5 5],'LineWidth',1.5,'Color','k');    
  

 
  h = legend('N(0,1) critical values', 'iid bootstrap (Bester et al.)','Spatial Dependent Wild Bootstrap (SDWB)', 'Orientation','Vertical');
 legend('boxon');
 set(h,'FontSize',8);
 set(h,'Location','NorthWest');

    
subplot(3,1,2,'replace');
plot(rho,out100(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out100(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out100(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 100');
    line([0 .9],[5 5],'LineWidth',2,'Color','k');
    ylim([0 60]);
    xlabel('\theta');
    ylabel('%');
yticks(5:5:60)

subplot(3,1,3,'replace');
plot(rho,out400(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out400(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out400(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 400')
ylim([0 60]);
xlabel('\theta');
ylabel('%');
yticks(5:5:60)

     line([0 .9],[5 5],'LineWidth',2,'Color','k');


orient portrait
      print -dpdf -fillpage figure4