% program for Conley, Goncalves, Kim, and Perron (QE, 2022)
% plots in Figure 5

% columns are
% N = 25  
%  N = 100
%   N = 400

% Lines are:

% iid
% CS-HAC
% white
% iid boot
% SDWB

% 10,000 reps

 
% max distance in DGP

DGP1_0 = [7.2	5.5	4.9
12.6	7.3	5.6
10.2	6.3	5.2
5.9	5.0	4.9
6.7	5.4	5.0
 ];
    
DGP1_1 = [9.6	8.5	9.9
15.2	8.9	7.3
13.7	10.0	10.1
7.3	5.8	5.8
7.5	5.8	5.6

    ];

DGP1_2 = [12.6	13.0	13.3
17.9	11.4	8.2
16.8	14.1	13.7
8.5	7.1	5.7
7.9	6.6	5.5


    ];

DGP1_3 = [16.0	17.6	19.5
20.9	14.1	9.8
21.0	19.0	20.1
10.5	8.1	6.3
9.3	6.9	5.9
];

DGP1_4 = [18.8	22.9	26.2
23.1	16.9	12.3
23.8	24.7	26.7
11.9	9.6	7.1
10.1	7.6	6.1

];

DGP1_5 = [22.0	29.4	34.6
26.0	20.5	14.7
27.4	31.3	35.4
13.9	11.5	8.5
11.8	8.4	6.6

];

DGP1_6 = [26.9	36.0	45.5
30.5	23.9	18.2
31.9	38.0	46.1
16.7	12.6	9.9
12.8	8.8	7.2

];

DGP1_7 = [29.8	43.8	55.4
32.8	28.8	22.5
35.3	45.9	56.1
17.9	15.5	12.1
14.0	9.5	7.7

];

DGP1_8 = [35.0	50.8	65.1
37.4	33.3	29.4
40.8	53.0	65.9
21.4	18.8	16.0
16.4	11.2	9.5

 ];

DGP1_9 = [39.1	56.5	73.9
41.4	39.2	36.5
44.6	58.2	74.8
24.7	23.3	21.2
19.1	13.5	11.8

  ];


rho = [0:.1:.9]';
out25 = [DGP1_0(2,1),DGP1_1(2,1),DGP1_2(2,1),DGP1_3(2,1),DGP1_4(2,1),DGP1_5(2,1),DGP1_6(2,1),DGP1_7(2,1),DGP1_8(2,1),DGP1_9(2,1)
        DGP1_0(4,1),DGP1_1(4,1),DGP1_2(4,1),DGP1_3(4,1),DGP1_4(4,1),DGP1_5(4,1),DGP1_6(4,1),DGP1_7(4,1),DGP1_8(4,1),DGP1_9(4,1)
    DGP1_0(5,1),DGP1_1(5,1),DGP1_2(5,1),DGP1_3(5,1),DGP1_4(5,1),DGP1_5(5,1),DGP1_6(5,1),DGP1_7(5,1),DGP1_8(5,1),DGP1_9(5,1)
   ];

out100 = [DGP1_0(2,2),DGP1_1(2,2),DGP1_2(2,2),DGP1_3(2,2),DGP1_4(2,2),DGP1_5(2,2),DGP1_6(2,2),DGP1_7(2,2),DGP1_8(2,2),DGP1_9(2,2)
        DGP1_0(4,2),DGP1_1(4,2),DGP1_2(4,2),DGP1_3(4,2),DGP1_4(4,2),DGP1_5(4,2),DGP1_6(4,2),DGP1_7(4,2),DGP1_8(4,2),DGP1_9(4,2)
       DGP1_0(5,2),DGP1_1(5,2),DGP1_2(5,2),DGP1_3(5,2),DGP1_4(5,2),DGP1_5(5,2),DGP1_6(5,2),DGP1_7(5,2),DGP1_8(5,2),DGP1_9(5,2)];


out400 = [DGP1_0(2,3),DGP1_1(2,3),DGP1_2(2,3),DGP1_3(2,3),DGP1_4(2,3),DGP1_5(2,3),DGP1_6(2,3),DGP1_7(2,3),DGP1_8(2,3),DGP1_9(2,3)
        DGP1_0(4,3),DGP1_1(4,3),DGP1_2(4,3),DGP1_3(4,3),DGP1_4(4,3),DGP1_5(4,3),DGP1_6(4,3),DGP1_7(4,3),DGP1_8(4,3),DGP1_9(4,3)
   DGP1_0(5,3),DGP1_1(5,3),DGP1_2(5,3),DGP1_3(5,3),DGP1_4(5,3),DGP1_5(5,3),DGP1_6(5,3),DGP1_7(5,3),DGP1_8(5,3),DGP1_9(5,3)] ;
   

subplot(3,1,1,'replace');
plot(rho,out25(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out25(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
 plot(rho,out25(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');
ylim([0 50]);
title('n = 25')
xlabel('\theta');
ylabel('%');
yticks(5:5:50)
  text(0,60,'Figure 5. Rejection rate, max distance in DGP, Euclidean in sample', 'FontSize',14,'FontWeight','bold'); 
%  
 line([0 .9],[5 5],'LineWidth',1.5,'Color','k');    
   
  h = legend('N(0,1) critical values', 'iid bootstrap (Bester et al.)','Spatial Dependent Wild Bootstrap (SDWB)', 'Orientation','Vertical');
 legend('boxon');
 set(h,'FontSize',8);
 set(h,'Location','NorthWest');

    
subplot(3,1,2,'replace');
plot(rho,out100(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out100(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out100(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 100');
    line([0 .9],[5 5],'LineWidth',2,'Color','k');
    ylim([0 50]);
    xlabel('\theta');
    ylabel('%');
yticks(5:5:50)

subplot(3,1,3,'replace');
plot(rho,out400(1,:)','LineWidth',2,'color','r','LineStyle','-','Marker','diamond');
hold on
plot(rho,out400(2,:)','LineWidth',2,'color','m','LineStyle','-','Marker','square');
plot(rho,out400(3,:)','LineWidth',2,'color','b','LineStyle','-','Marker','o');

title('n = 400')
ylim([0 50]);
xlabel('\theta');
ylabel('%');
yticks(5:5:50)

     line([0 .9],[5 5],'LineWidth',2,'Color','k');


orient portrait
      print -dpdf -fillpage figure5